//HavokLevel.cpp
#include "HavokLevel.h"

#include <stdexcept>
#include <Physics/Dynamics/World/hkpWorld.h>
#include <Common/Serialize/Util/hkRootLevelContainer.h>
#include <Common/Serialize/Util/hkLoader.h>
#include <Physics/Utilities/Serialize/hkpPhysicsData.h>
#include <Physics/Dynamics/Entity/hkpRigidBody.h>

#include "HavokManager.h"


HavokLevel* HavokLevel::m_pInstance = 0L;

#if  0
	//
	// Load an asset
	//

	//hkString assetFile = "grassfield.hkx"; //hkAssetManagementUtil::getFilePath("Tree.hkx");
	hkLoader* m_loader = new hkLoader();
	//hkRootLevelContainer* container = m_loader->load("../physics/testTrack01.hkx"); // prototype level
	//hkRootLevelContainer* container = m_loader->load("../physics/iteration3/collisionMesh.hkx");

	hkRootLevelContainer* container = m_loader->load("../physics/sceneFile.hkx");

	if(!container)
	{
		throw std::runtime_error("Can't load collision mesh ");
	}

	HK_ASSERT2(0xaefe9356, container != HK_NULL , "Could not load asset");

	hkpPhysicsData* physics = static_cast<hkpPhysicsData*>( container->findObjectByType( hkpPhysicsDataClass.getName() ) );
	HK_ASSERT2(0x245982ae, physics != HK_NULL, "Could not find physics data in root level object" );
	//HK_ASSERT2(0xa6451535, physics->getWorldCinfo() != HK_NULL, "No physics cinfo in loaded file - cannot create a hkpWorld" );

	// Add all the physics systems to the world
	for ( int i = 0; i < physics->getPhysicsSystems().getSize(); ++i )
	{
		mWorld->addPhysicsSystem( physics->getPhysicsSystems()[i] );
	}

#endif

bool HavokLevel::CreateInstance()
{
	if( m_pInstance )
		return false;

	m_pInstance = new HavokLevel();
	bool bRes = m_pInstance->Init();
	return bRes;
}
//--------------------------------------------------------------------------------
void HavokLevel::ReleaseInstance()
{
	if( m_pInstance == 0L )
		return;
	
	m_pInstance->UnInit();
	delete m_pInstance;
	m_pInstance = 0L;
}
HavokLevel::HavokLevel()
{

}
//------------------------------------------------------------------------------------------------
HavokLevel::~HavokLevel()
{

}
//------------------------------------------------------------------------------------------------
hkpRigidBody* HavokLevel::AddWorld( const char* fileName )
{
	hkLoader* loader = HavokManager::Instance()->GetLoader();
	hkRootLevelContainer* container = loader->load( fileName );
	if(!container)
	{
		throw std::runtime_error("Can't load collision mesh ");
	}

	HK_ASSERT2(0xaefe9356, container != HK_NULL , "Could not load asset");
	hkpPhysicsData* physics = static_cast<hkpPhysicsData*>( container->findObjectByType( hkpPhysicsDataClass.getName() ) );
	HK_ASSERT2(0x245982ae, physics != HK_NULL, "Could not find physics data in root level object" );

	hkpRigidBody* pRigidBody = physics->getPhysicsSystems()[0]->getRigidBodies()[0];
	pRigidBody->setPosition(hkVector4(90,0,0));

	hkpWorld* pWorld = HavokManager::Instance()->GetWorld();
	pWorld->markForWrite();
	pWorld->addEntity(pRigidBody);
	pRigidBody->removeReference();
	pWorld->unmarkForWrite();
	return pRigidBody;
}
//------------------------------------------------------------------------------------------------
hkpPhysicsData* HavokLevel::AddPhysicsSystem( const char* fileName )
{
	hkLoader* loader = HavokManager::Instance()->GetLoader();
	hkRootLevelContainer* container = loader->load( fileName );
	if(!container)
	{
		throw std::runtime_error("Can't load collision mesh ");
	}

	HK_ASSERT2(0xaefe9356, container != HK_NULL , "Could not load asset");
	hkpPhysicsData* physics = static_cast<hkpPhysicsData*>( container->findObjectByType( hkpPhysicsDataClass.getName() ) );
	HK_ASSERT2(0x245982ae, physics != HK_NULL, "Could not find physics data in root level object" );

	hkpWorld* pWorld = HavokManager::Instance()->GetWorld();
	pWorld->lock();

	// Add all the physics systems to the world
	for ( int i = 0; i < physics->getPhysicsSystems().getSize(); ++i )
	{
		pWorld->addPhysicsSystem( physics->getPhysicsSystems()[i] );
	}

	pWorld->unlock();
	return physics;
}
//------------------------------------------------------------------------------------------------


//------------------------------------------------------------------------------------------------